/*
  Copyright (C) 2001-2003 Mahlon E. Smith <mahlon@martini.nu>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either
  version 2 of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <unistd.h>
#include <stdio.h>

/* Verify that a binary is in a working path */
/* Return 0 on success, -1 on failure. */
int check_exe(char binary[20])
{
  int strncpy(), strcat(), strtok(), getenv();
  int result = -1;
  char envpath[200];
  char binarypath[150];
  char *path;
  char *sep = ":";
  
  strncpy(envpath, getenv("PATH"), sizeof(envpath));
  for((int)path = strtok(envpath, sep); 
      path;
      (int)path = strtok(NULL, sep))
    {
      strcpy(binarypath, path);
      strcat(binarypath, "/");
      strcat(binarypath, binary);
      result = access(binarypath, X_OK);
     
      if (result == 0) { 
#ifdef DEBUG
	printf("Found %s at %s\n", binary, path);
#endif DEBUG
	break; 
      }  
    }
  return(result);
}
