/*
  Copyright (C) 2001-2003 Mahlon E. Smith <mahlon@martini.nu>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either
  version 2 of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string.h>
#include <stdio.h>

/* 
   Sanity check a given IP address.
   Splits the IP on periods, checks each octet range.
*/

int check_ip(char *ip)
{

  int periodcount = 0;
  int iptest;
  char *period = ".";
  char *get_ip;
  char testip[16];

  strcpy(testip, ip);
  for((int)get_ip = strtok(testip, period); 
      get_ip;
      (int)get_ip = strtok(NULL, period))
    {
      ++periodcount;
      sscanf(get_ip, "%d", &iptest);
      if (iptest > 255 || iptest < 0) {
	return(1);
      }
    }
  if (periodcount != 4) {
    return(1);
  }
  
  return(0);  
}

