/*
  Copyright (C) 2001-2003 Mahlon E. Smith <mahlon@martini.nu>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either
  version 2 of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <gtk/gtk.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "globals.h"
#include "gtkglobals.h"

/* 
   Retrieve gateway IP address, set global var.

   Since there really isn't an easy way to do this, we
   let the StaticCling server do the real work, and simply
   initiate another http connection to retrieve what the 
   user's "real" IP address is.
*/

int get_gwip()
{

  FILE *http;
  char url[] = "http://www.staticcling.org/ip.html"; 
  char command[200];
  char shellcommand[500];
  char prox[150];
  int shellexit;

  void update_status();
  int check_ip();

  /* Build the shell command */
  sprintf(command, "%s %s%s%s", HTTP, "-q -T 15 -U 'ChargeGTK/", VERSION, "-getip' -O -");
  sprintf(shellcommand, "%s '%s'", command, url);

#ifdef DEBUG
  printf("Retrieving gateway IP ");
#endif DEBUG

  /* Shove the proxy server into the env */
  if ((uproxy == 1) && (strlen(proxy_server) > 0)) {
#ifdef DEBUG
      printf("- using proxy");
#endif DEBUG
      sprintf(prox, "http_proxy=http://%s/", proxy_server);
      putenv(prox);
  }
  if ((uproxy == 0) || (strlen(proxy_server) == 0)) {
      unsetenv("http_proxy");
  }

#ifdef DEBUG
  printf("\nLaunching: %s\n", shellcommand);
#endif DEBUG

  http = popen(shellcommand, "r");
  fflush(http);
  fgets(ip, sizeof(ip), http);

  shellexit = (pclose(http) / 255);
#ifdef DEBUG
  printf("Command exitcode: %d\n", shellexit);
  /* Catch and report errors */
  /* Can't connect  - not a 404 since we know the URL */
  if (shellexit == 1) {
    update_status("Unable to connect to server.");
    printf("Unable to connect, please try again later.\n");
    return(1);
  } else if (shellexit != 0) { /* Catchall */
    update_status("Unknown error.");
    printf("Unknown error!\n");
    return(1);
  }
#endif DEBUG

  if (check_ip(ip)) { return(1); }
  
  /* All is well at this point. */
  update_status("Retrieved gateway IP.");
#ifdef DEBUG
  printf("IP found: %s\n", ip);
#endif DEBUG
  
  return(0);  
}


