/*
  Copyright (C) 2001-2003 Mahlon E. Smith <mahlon@martini.nu>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either
  version 2 of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
  Retrieves data in textfields, 
  Verifies data as valid, and sets 
  global variables.
*/

#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include "globals.h"
#include "gtkglobals.h"

int getfields() 
{

  void update_status();
  int periodcount = 0;
  int iptest;
  char *period = ".";
  char *get_ip;
  char testip[16];

  /* Retrieve info from fields */
  strcpy(hostname, gtk_entry_get_text(GTK_ENTRY(hostnamebox)));
  strcpy(password, gtk_entry_get_text(GTK_ENTRY(passwordbox)));
  strcpy(ip, gtk_entry_get_text(GTK_ENTRY(ipbox)));
  
  /* Sanity check */
  if (strlen(hostname) == 0) {
    update_status("Enter a hostname.");
    return(1);
  }
  if (strlen(password) == 0) {
    update_status("Enter a password.");
    return(1);
  }
  if (strlen(password) < 5) {
    update_status("Password is too short.");
    return(1);
  }
  if (strlen(ip) < 7) {
    update_status("Invalid IP.");
    return(1);
  }
  strcpy(testip, ip);
  for((int)get_ip = strtok(testip, period); 
      get_ip;
      (int)get_ip = strtok(NULL, period))
    {
      ++periodcount;
      sscanf(get_ip, "%d", &iptest);
      if (iptest > 255 || iptest < 0) {
	update_status("Invalid IP.");
	return(1);
      }
    }
  if (periodcount != 4) {
    update_status("Invalid IP.");
    return(1);
  }

  return(0);
}
