/*
  Copyright (C) 2001-2003 Mahlon E. Smith <mahlon@martini.nu>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either
  version 2 of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "globals.h"
#include <string.h>
#include <stdio.h>

/* 
   Retrieve current IP address, set global var.

   This is the extremely lazy and probably non portable way to do it.
   I could probably use uname() and gethostbyname(), but since
   that relies on DNS/Hosts, and this is a *dynamic* DNS client, 
   that would kind of defy the entire point.  Hmmm.
   Eventually, I'll rip into the ifconfig or netstat code, and 
   figure out how to get the info from the actual binding on the NIC.
   For now... whatever works.  Should be trivial to change the 
   command for the sake of portability.
*/

int getip()
{

  FILE *shell_ip;
  char command[200];
  int shellexit;

  int check_ip();
  
  sprintf(command, "%s %s %s %s", IFCONFIG, "-a |", AWK, "'/inet / {print $2; exit}'");
  shell_ip = popen(command, "r");
  fflush(shell_ip);
  fgets(ip, sizeof(ip), shell_ip);
  shellexit = (pclose(shell_ip) / 255);

  /* Remove the newline */
  if (ip[strlen(ip) - 1] == '\n') {
    ip[strlen(ip) - 1] = '\0';
  }
  
  if (shellexit) { return(1); }
  if (check_ip(ip)) { return(1); }
  
  /* All is well at this point. */
#ifdef DEBUG
  printf("IP found: %s\n", ip);
#endif DEBUG
  
  return(0);  
}


