/*
  Copyright (C) 2001-2003 Mahlon E. Smith <mahlon@martini.nu>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either
  version 2 of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


/* 
   Takes a message, places it into 
   the status bar in the main window. 
   update_status("boing");

   We're also doing the new client check here.
*/

#include <gtk/gtk.h>
#include "gtkglobals.h"
#include "globals.h"
#include <string.h>

void update_status(
		   char info[]
		   )
{

  void gerror();
  char message[150];

  /* Check for the '*' char - if we see it, we're running an old client. */
  if (strncmp("Success.*", info, strlen("Success.*")+1) == 0) { /* match */
	info[8] = '\0'; /* Trim off the '*' */

  	/* Bring up a dialog if the prefs allow. */
	if (checkv == 1) {
		gerror("A newer client was found!\nPlease upgrade at http://www.staticcling.org/", 0);
  	}
  }

  /* Add a space before the message - it's prettier. */
  strcpy(message, " ");
  strcat(message, info);
 
  gtk_statusbar_push(
		     GTK_STATUSBAR(status_bar), 
		     status_id, 
		     message
		     );
  return;
}
