/*
  Copyright (C) 2001-2003 Mahlon E. Smith <mahlon@martini.nu>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either
  version 2 of the License, or any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
  Calls an external program (http) to do the actual work.
  Returns 0 if successful, 1 if not.
  Sets global var 'status'
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "globals.h"

int update()
{
  
  FILE *http;
  char url[] = "http://www.staticcling.org/update.html"; 
  char command[200];
  char shellcommand[500];
  char status[200];
  char prox[150];
  int shellexit;

  void gerror();
  int getfields();
  void update_status();
  
  /* Retrieve info here */
  if (getfields() == 1) {
    return(1);
  }

  /* Build the shell command */
  sprintf(command, "%s %s%s%s", HTTP, "-q -T 15 -U 'ChargeGTK/", VERSION, "' -O -");
  sprintf(shellcommand, "%s '%s?login=%s&pass=%s&ip=%s'",
	command, url, hostname, password, ip);

#ifdef DEBUG
  printf("Update button clicked ");
#endif DEBUG

  /* Shove the proxy server into the env for http */
  if ((uproxy == 1) && (strlen(proxy_server) > 0)) {
#ifdef DEBUG
      printf("- using proxy");
#endif DEBUG
      sprintf(prox, "http_proxy=http://%s/", proxy_server);
      putenv(prox);
  }
  if ((uproxy == 0) || (strlen(proxy_server) == 0)) {
      unsetenv("http_proxy");
  }

#ifdef DEBUG
  printf("\nLaunching: %s\n", shellcommand);
#endif DEBUG

  http = popen(shellcommand, "r");
  fflush(http);
  fgets(status, sizeof(status), http);
  
  shellexit = (pclose(http) / 255);
#ifdef DEBUG
  printf("%s\n", status);
  printf("Command exitcode: %d\n\n", shellexit);
#endif DEBUG
  /* Catch and report errors */
  /* Can't connect - not a 404 since we know the URL */
  if (shellexit == 1) {
    update_status("Connection error.");
    gerror("Unable to connect, please try again later.", 0);
    return(1);
  } else if (shellexit != 0) { /* Catchall */
    update_status("Unknown error.");
    gerror("Unknown error!", 1);
    return(1);
  }

  if (shellexit == 0) { update_status(status); }

  return(0);
}
